(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global.jqueryRegister = factory());
})(this, function(){

    /**
     * 返回 jquery 插件的操作对象
     * @return {[type]} [description]
     */
    function handleWraper($plugs, plugname) {
        var onehandle = jQuery[plugname].prototype;
        var handle = {};
        // 获取组件中的方法，添加到新的 handle 对象中
        for (var key in onehandle) {
            if (typeof onehandle[key] === 'function') {
                (function() {
                    var methodName = key;
                    // 将方法添加到 handle
                    handle[methodName] = function() {
                        var outArguments = arguments;
                        $plugs.each(function() {
                            var handle = $(this).data('widget-handle-' + plugname);
                            if (!!handle) {
                                onehandle[methodName].apply(handle, outArguments);
                            }
                        });
                        return handle;
                    }
                })();

            }
        }
        return handle;
    }
    /**
     * 通过构造函数注册jquery插件
     * @param  {String} plugname        插件名称
     * @param  {Function} constructor   构造函数
     */
    function registerFromConstructor(plugname, constructor) {
        // 将类暴露到 jQuery 变量下便于扩展
        jQuery[plugname] = constructor;

        $.fn[plugname] = function(options) {

            if (options === undefined) {
                // 如果没有选项，则返回所有已经初始化为插件的对象
                var $plugs = this.filter(function() {
                    // 返回已经被初始化为插件的元素
                    var handle = $(this).data('widget-handle-'+plugname);
                    if(!!handle){
                        return true;
                    }else{
                        return false;
                    }
                });
                // 返回句柄对象
                return handleWraper($plugs, plugname);
            } else {
                // 如果没有选项，则将选择器中的所有内容进行插件初始化，并且全部返回
                var $plugs = this.each(function() {
                    var $this = $(this);
                    // 实例化控件
                    var someWidget = new constructor();
                    // 初始化控件
                    options.el = $this;
                    someWidget.init(options);
                    // 保存句柄
                    $this.data('widget-handle-' + plugname, someWidget);
                });
                // 返回句柄对象
                return handleWraper($plugs, plugname);
            }
        };
    };

    return {
        registerFromConstructor: registerFromConstructor
    }
})